require 'wise/label'

module Wise
  module Popup
    def initialize(parent, settings={})
      super(parent, {:map=>false, :override=>true, :saveunder=>true}.update(settings))
    end

    def popup(nx, ny)
      #puts "#{self}"
      #puts "#{nx} + #{total_width} > #{display.root.width} ?"
      nx = display.root.width - total_width  if (nx + total_width > display.root.width)
      nx = 0  if (nx < 0)
      # width = display.root.width  if width > display.root.width
      ny = display.root.height - height  if (ny + height > display.root.height)
      ny = 0  if (ny < 0)
      # height = display.root.height  if height > display.root.height
      settings[:x], settings[:y] = nx, ny
      # move(nx, ny)
      map()
    end
  end

  class ToolTip < Label
    include Popup
    def initialize(parent, settings={})
      super(parent, {}.update(settings))
    end
  end
end
